#!/usr/bin/env python
# alldesc.py

import os

_extensions = {
    '.com': 1,
    '.lnk': 1,
    '.shm': 1,
    '.dld': 1,
    '.rel': 1,
    '.lib': 1,
    '.mac': 1,
    '.jpr': 1,
    '.shr': 1,
}

def writeDescriptionFiles (data, dirname, files):
    splitext = os.path.splitext
    for file in files:
        ext = splitext (file) [1]
        if _extensions.has_key (ext):
            print os.path.join (dirname, file)

def alldesc ():
    paths = ['desc', 'src' + os.sep + 'SAPDB']
    for path in paths:
        path = os.path.join (os.environ ['OWN'], 'sys', path)
        os.path.walk (path, writeDescriptionFiles, None)

def main (options, args):
    """write all description files to stdout
    
    The output is suitable for xargs
    """
    alldesc ()

def _options ():
    return [
        # (optstring, varname, typechar, default, help)
        ]

if __name__ == '__main__':
    import optlib
    optlib.optMain2 (main, _options ())
