
# integrateChangelist.py

import sys
from perforce.integrateLib import simpleIntegrate

def integrateChangelist (options, changeid):
    return simpleIntegrate (changeid, options.branch, options)

def fatalError (msg):
    sys.stderr.write ('integrateChanglist: ' + msg + '\n')
    sys.exit (2)

def checkOptions (options):
    if not options.branch:
        fatalError ('option -b must be specified')

def main (options, args):
    """integrates changes specific to a change list

    Any additional arguments are numbers of change lists.

    """
    checkOptions (options)
    for arg in args:
        newid = integrateChangelist (options, arg)
        if not options.changeList:
            print 'info: new change list ' + str (newid)

def _options ():
    return [
        # (optstring, varname, typechar, default, help)
        ('b', 'branch', ':', None, 'branch name'),
        ('c', 'changeList', ':', 0, 'use existing change list'),
        ('r', 'reverse', '', None, 'reverse integration'),
        ]

if __name__ == '__main__':
    import optlib
    optlib.optMain2 (main, _options ())
