#!/usr/bin/perl
#
# T. Simenec
#  SAP AG
#####################

use Env;
use Getopt::Std;
use PTools;


$SCRIPTNAME="PNEW";

getopts('vse:');

if ( @ARGV == 0 && !defined($opt_h))  {Usage();}

if ($opt_s && $opt_v)
{
	die "Error-$SCRIPTNAME: Option -v with -s not allowed\n";
}

$verbose=$opt_v ? 2 : $opt_s ? 0 : 1;

@failed_modules=();
$rc=PTools::pnew(\@ARGV, $opt_e, \@failed_modules, $verbose );

caller() ? ($rc != 0) : exit($rc != 0) ;


sub Usage {

  print <<End;
usage: pnew [-e editor] [-v|-s] files";
         -v verbose
         -s silent
End
  exit 1;
}
